﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Windows.Forms;

namespace Esempio4
{
    public partial class Form7 : Form
    {
        public Form7()
        {
            InitializeComponent();
            Application.Idle += Application_Idle;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox checkBox = (CheckBox) sender;
            _errorProvider.SetError(checkBox, checkBox.Checked ? "" : "Deve essere checked!");
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            TextBox textBox = (TextBox) sender;
            _errorProvider.SetError(textBox, textBox.Text != "" ? "" : "Scrivi qualcosa!");
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void _startButton_Click(object sender, EventArgs e)
        {
            //_serviceController.Start();
            DoAction(_serviceController.Start);
        }

        private void _stopButton_Click(object sender, EventArgs e)
        {
            //_serviceController.Stop();
            DoAction(_serviceController.Stop);
        }

        private void DoAction(Action action)
        {
            try
            {
                action();
            }
            catch (Exception ex)
            {
                using (ThreadExceptionDialog dialog = new ThreadExceptionDialog(ex))
                {
                    dialog.ShowDialog();
                }
            }
        }

        private void Application_Idle(object sender, EventArgs e)
        {
            _serviceController.Refresh();
            switch (_serviceController.Status)
            {
                case ServiceControllerStatus.Running:
                    _startButton.Enabled = false;
                    _stopButton.Enabled = true;
                    break;
                case ServiceControllerStatus.Stopped:
                    _startButton.Enabled = true;
                    _stopButton.Enabled = false;
                    break;
                default:
                    _startButton.Enabled = false;
                    _stopButton.Enabled = false;
                    break;
            }
            _serviceStatusLabel.Text = _serviceController.Status.ToString();
        }
    }
}
